From f20c9b786a54d3364fd88f20f6aab027d41059e0 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 18:22:01 +0000
Subject: [PATCH 1269/2232] Start building structured dependency information


---

diff --git a/gen/build/src/deps.rs b/gen/build/src/deps.rs
index 05a15d3..57e96c9 100644
--- a/gen/build/src/deps.rs
+++ b/gen/build/src/deps.rs
@@ -2,8 +2,15 @@ use std::collections::BTreeMap;
 use std::env;
 use std::path::PathBuf;
 
-pub fn include_dirs() -> impl Iterator<Item = PathBuf> {
-    let mut env_include_dirs = BTreeMap::new();
+#[derive(Default)]
+pub struct Crate {
+    pub crate_dir: Option<PathBuf>,
+    pub include_dir: Option<PathBuf>,
+}
+
+pub fn direct_dependencies() -> Vec<Crate> {
+    let mut crates: BTreeMap<String, Crate> = BTreeMap::new();
+
     for (k, v) in env::vars_os() {
         let mut k = k.to_string_lossy().into_owned();
         // Only variables set from a build script of direct dependencies are
@@ -22,17 +29,15 @@ pub fn include_dirs() -> impl Iterator<Item = PathBuf> {
         //   - https://doc.rust-lang.org/cargo/reference/build-scripts.html#the-links-manifest-key
         //   - https://doc.rust-lang.org/cargo/reference/build-script-examples.html#using-another-sys-crate
         if k.starts_with("DEP_") {
-            if k.ends_with("_CXXBRIDGE_INCLUDE") {
-                // Tweak to ensure sorted before the other one, for the same
-                // reason as the comment on ordering of include_dir vs crate_dir
-                // above.
-                k.replace_range(k.len() - "INCLUDE".len().., "0");
-                env_include_dirs.insert(k, PathBuf::from(v));
-            } else if k.ends_with("_CXXBRIDGE_CRATE") {
-                k.replace_range(k.len() - "CRATE".len().., "1");
-                env_include_dirs.insert(k, PathBuf::from(v));
+            if k.ends_with("_CXXBRIDGE_CRATE") {
+                k.truncate(k.len() - "_CXXBRIDGE_CRATE".len());
+                crates.entry(k).or_default().crate_dir = Some(PathBuf::from(v));
+            } else if k.ends_with("_CXXBRIDGE_INCLUDE") {
+                k.truncate(k.len() - "_CXXBRIDGE_INCLUDE".len());
+                crates.entry(k).or_default().include_dir = Some(PathBuf::from(v));
             }
         }
     }
-    env_include_dirs.into_iter().map(|entry| entry.1)
+
+    crates.into_iter().map(|entry| entry.1).collect()
 }
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 6908f3c..b684a25 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -65,6 +65,7 @@ mod syntax;
 mod target;
 mod vec;
 
+use crate::deps::Crate;
 use crate::error::{Error, Result};
 use crate::gen::error::report;
 use crate::gen::Opt;
@@ -177,8 +178,8 @@ impl Project {
 fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Result<Build> {
     let ref prj = Project::init()?;
 
-    let ref crate_dir = make_crate_dir(prj);
-    let ref include_dir = make_include_dir(prj)?;
+    let crate_dir = make_crate_dir(prj);
+    let include_dir = make_include_dir(prj)?;
 
     let mut build = Build::new();
     build.cpp(true);
@@ -188,21 +189,31 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
         generate_bridge(prj, &mut build, path.as_ref())?;
     }
 
+    let mut crates = deps::direct_dependencies();
+    crates.insert(
+        0,
+        Crate {
+            crate_dir,
+            include_dir: Some(include_dir),
+        },
+    );
+
     eprintln!("\nCXX include path:");
-    build.include(include_dir);
-    eprintln!("  {}", include_dir.display());
-    if let Some(crate_dir) = crate_dir {
-        // Placed after the generated code directory (include_dir) on the
-        // include line so that `#include "path/to/file.rs"` from C++
-        // "magically" works and refers to the API generated from that Rust
-        // source file.
-        build.include(crate_dir);
-        eprintln!("  {}", crate_dir.display());
-    }
-    for dep in deps::include_dirs() {
-        build.include(&dep);
-        eprintln!("  {}", dep.display());
+    for krate in crates {
+        if let Some(include_dir) = &krate.include_dir {
+            build.include(include_dir);
+            eprintln!("  {}", include_dir.display());
+        }
+        if let Some(crate_dir) = &krate.crate_dir {
+            // Placed after the generated code directory (include_dir) on the
+            // include line so that `#include "path/to/file.rs"` from C++
+            // "magically" works and refers to the API generated from that Rust
+            // source file.
+            build.include(crate_dir);
+            eprintln!("  {}", crate_dir.display());
+        }
     }
+
     Ok(build)
 }
 

